<?php

namespace IPS\musicbox\extensions\core\CreateMenu;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * Create Menu Extension
 */
class _MusicBox
{
	/**
	 * Get Items
	 *
	 * @return	array
	 */
	public function getItems()
	{		
		$return = array();
		if ( \IPS\musicbox\Category::canOnAny( 'add' ) )
		{
			$return['musicbox_post'] = array(
					'link' 		=> \IPS\Http\Url::internal( "app=musicbox&module=musicbox&controller=post&do=postSong&_new=1", 'front', 'musicbox_postSong' ),
					'title' 	=> 'musicbox_post',
					'extraData'	=> array( 'data-ipsDialog' => true, 'data-ipsDialog-size' => "narrow" )
				);
		}
		
		if ( \IPS\musicbox\Category::canOnAny( 'plist' ) )
		{
			$return['musicbox_postPlaylist'] =  array(
					'link' 					=> \IPS\Http\Url::internal( "app=musicbox&module=musicbox&controller=post&do=createPlaylist&_new=1", 'front', 'musicbox_createPlaylist' ),
					'title' 				=> 'musicbox_postPlaylist',
					'extraData'				=> array( 'data-ipsDialog' => true, 'data-ipsDialog-size' => "narrow" )
				);
		}
		
		return $return;
	}
}