//<?php

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	exit;
}

class musicbox_hook_Rss extends _HOOK_CLASS_
{
	public function musicboxGetItems( $guidKey=NULL )
	{
		try
		{
			$articles	= array();
			$items		= $this->getItems();
			
			foreach ( $items as $item )
			{
				$link = NULL;
				if ( isset( $item->link ) AND $item->link )
				{
					try
					{
						$link = \IPS\Http\Url::external( (string) $item->link );
					}
					catch ( \Exception $e ) {  }
				}
				
				if ( isset( $item->guid ) )
				{
					$guid = $item->guid;
				}
				else
				{
					$guid = '';
					foreach ( array( 'title', 'link', 'description' ) as $k )
					{
						if ( isset( $item->$k ) )
						{
							$guid .= $item->$k;
						}
					}
					$guid = preg_replace( "#\s|\r|\n#is", "", $guid );
				}
				$guid = md5( $guidKey . $guid );
	
				$text = isset( $item->description ) ? (string) $item->description : (string) $item->title;
	
				/* If there is a <content:encoded> tag, get the contents of that instead of description */
				if( \count( $item->children( 'content', true ) ) AND \count( $item->children( 'content', true )->encoded ) )
				{
					$text = (string) $item->children( 'content', true )->encoded[0];
				}
	
				/* Some feeds may not provide a pubDate for the Item or Channel in the feed. Work out which one exists and if neither do, use the current time */
				$pubDate = $this->getDate( $item );
				
				if ( $pubDate === NULL AND $this->channel->pubDate )
				{
					$pubDate = \IPS\DateTime::ts( strtotime( $this->channel->pubDate ), TRUE );
				}
	
				$articles[ $guid ] = array(
					'title'		=> ( (string) $item->title ) ?: ( mb_substr( $text, 0, 47 ) . '...' ),
					'content'	=> (string) $text,
					'date'		=> $pubDate ?: \IPS\DateTime::create(),
					'link'		=> $link,
					'author'	=> (string) $item->author,
					'media'		=> (string) $item->enclosure['url'],
				);
			}
			return $articles;
		}
		catch ( \Error | \RuntimeException $e )
		{
			if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
			{
				\IPS\Log::log( $e, 'hook_exception' );
			}

			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}

}
