//<?php

abstract class musicbox_hook_SearchIndex extends _HOOK_CLASS_
{
	public function indexData( \IPS\Content\Searchable $object )
	{
		try
		{
			$return = parent::indexData( $object );
			if ( \get_class( $object ) == 'IPS\musicbox\Song' )
			{
				$return['index_title'] = $return['index_title'] . " - " . $object->mapped('singer');
				if ( \count($object->customFields()) > 0 )
				{
					$return['index_content'] = $return['index_content'] . "\n" . "(" . implode(", ", $object->customFields()) . ")";
				}
			}		
			return $return;
		}
		catch ( \Error | \RuntimeException $e )
		{
			if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
			{
				\IPS\Log::log( $e, 'hook_exception' );
			}

			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}

}