//<?php

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	exit;
}

abstract class musicbox_hook_embed extends _HOOK_CLASS_
{
	protected function embed()
	{
		try
		{
			if ( static::$contentModel != 'IPS\musicbox\Song' )
			{
				parent::embed();
			}
			else
			{
				$title = \IPS\Member::loggedIn()->language()->addToStack('error_title');
			
				try
				{
					$class = static::$contentModel;
					$params = array();
									
					if ( isset( \IPS\Request::i()->page ) and \IPS\Request::i()->page > 1 )
					{
						$params['page'] = \intval( \IPS\Request::i()->page );
					}
					if ( isset( \IPS\Request::i()->embedDo ) )
					{
						$params['do'] = \IPS\Request::i()->embedDo;
					}
					
					$content = $class::loadAndCheckPerms( \IPS\Request::i()->id );
					$title = $content instanceof \IPS\Node\Model ? $content->_title : $content->mapped('title');
	
					if ( !( $content instanceof \IPS\Content\Embeddable ) )
					{
						$output = \IPS\Theme::i()->getTemplate( 'embed', 'core', 'global' )->embedUnavailable();
					}
					else
					{
						$output = $content->embedContent( $params );
					}
					
				}
				catch( \Exception $e )
				{
					$output = \IPS\Theme::i()->getTemplate( 'embed', 'core', 'global' )->embedNoPermission();
				}
				
				\IPS\Output::i()->base = '_parent';
				\IPS\Output::i()->cssFiles = array_merge( \IPS\Output::i()->cssFiles, \IPS\Theme::i()->css( 'embed.css' ) );
				\IPS\Output::i()->sendOutput( \IPS\Theme::i()->getTemplate( 'global', 'core' )->blankTemplate( $output, $title ), 200, 'text/html', \IPS\Output::i()->httpHeaders );			
			}
		}
		catch ( \Error | \RuntimeException $e )
		{
			if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
			{
				\IPS\Log::log( $e, 'hook_exception' );
			}

			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}

}
