//<?php

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !\defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	exit;
}

abstract class musicbox_hook_includeJSandCSS extends _HOOK_CLASS_
{

	protected static function baseJs()
	{
		try
		{
			parent::baseJS();
			if ( !\IPS\Request::i()->isAjax() && \IPS\Request::i()->do == 'embed' )
			{
				\IPS\Output::i()->jsFiles = array_merge( \IPS\Output::i()->jsFiles, \IPS\Output::i()->js( 'embed.js', 'musicbox', 'interface' ) );
			}
	
			if ( !\IPS\Request::i()->isAjax() )
			{
				\IPS\Output::i()->jsFiles = array_merge( \IPS\Output::i()->jsFiles, \IPS\Output::i()->js( 'front_musicbox.js', 'musicbox', 'front' ) );
			}
			
			\IPS\Output::i()->jsFiles = array_merge( \IPS\Output::i()->jsFiles, \IPS\Output::i()->js( 'background.js', 'musicbox', 'interface' ) );	
			\IPS\Output::i()->jsVars['musicBoxDefaultAutoPlay'] = \IPS\Settings::i()->mbconf_autoplay_default;	
			\IPS\Output::i()->jsVars['musicBoxPlayerBar'] = \IPS\Settings::i()->mbconf_playerbar_all;	
			\IPS\Output::i()->jsVars['musicBoxCanPlayRandom'] = 1;	
			\IPS\Output::i()->jsVars['musicBoxUpdateURL'] = \IPS\Settings::i()->mbconf_update_url;	
			\IPS\Output::i()->jsVars['musicBoxGlobalSearch'] = \IPS\Settings::i()->mbconf_global_search;	
		}
		catch ( \Error | \RuntimeException $e )
		{
			if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
			{
				\IPS\Log::log( $e, 'hook_exception' );
			}

			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
	
	public static function baseCss()
	{
		try
		{
			parent::baseCss();
			
			if ( ! \IPS\Request::i()->isAjax() )
			{
				\IPS\Output::i()->cssFiles = array_merge( \IPS\Output::i()->cssFiles, \IPS\Theme::i()->css( 'musicbox.css', 'musicbox', 'front' ) );
			}
		}
		catch ( \Error | \RuntimeException $e )
		{
			if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
			{
				\IPS\Log::log( $e, 'hook_exception' );
			}

			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
	
}
