<?php


namespace IPS\musicbox\modules\admin\musicbox;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * artists
 */
class _artists extends \IPS\Node\Controller
{
	
	/**
	 * @brief	Has been CSRF-protected
	 */
	public static $csrfProtected = TRUE;
	
	/**
	 * Node Class
	 */
	protected $nodeClass = 'IPS\musicbox\Artist';
	
	/**
	 * Execute
	 *
	 * @return	void
	 */
	public function execute()
	{
		\IPS\Dispatcher::i()->checkAcpPermission( 'artists_manage' );
		
		\IPS\Output::i()->sidebar['actions'] = array();

		\IPS\Output::i()->sidebar['actions']['permArtists'] = array(
			'icon'	=> 'cog',
			'link'	=> \IPS\Http\Url::internal( 'app=musicbox&module=musicbox&controller=artists&do=permissions' ),
			'title'	=> 'musicbox_permArtists',
			'data'	=>  array( 'ipsDialog' => true, 'ipsDialog-size' => 'narrow', 'ipsDialog-title' => \IPS\Member::loggedIn()->language()->addToStack('musicbox_permArtists') )

		);
		
		parent::execute();
	}
	
	/**
	 * Manage Artists
	 */
	protected function manage()
	{
		parent::manage();
	}
	
	protected function permissions()
	{
		$form = new \IPS\Helpers\Form;
		$form->add( new \IPS\Helpers\Form\Select( 'mbconf_artists_perm', \IPS\Settings::i()->mbconf_artists_perm ? array_filter( explode( ',', \IPS\Settings::i()->mbconf_artists_perm ) ) : FALSE, FALSE, array( 'options' => \IPS\Member\Group::groups(), 'parse' => 'normal', 'multiple' => TRUE ) ) );
		$form->class = 'ipsPad ipsForm_vertical';
		
		/* Save */
		if ( $values = $form->values( TRUE ) )
		{
			$form->saveAsSettings( $values );
			\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=musicbox&module=musicbox&controller=artists' ) );
		}
		
		/* Output */
		\IPS\Output::i()->title = \IPS\Member::loggedIn()->language()->addToStack('musicbox_permArtists');
		\IPS\Output::i()->output = $form;			
	}	
}