<?php


namespace IPS\musicbox\modules\front\musicbox;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * search
 */
class _search extends \IPS\Dispatcher\Controller
{
	/**
	 * Execute
	 *
	 * @return	void
	 */
	public function execute()
	{
		
		parent::execute();
	}

	/**
	 * ...
	 *
	 * @return	void
	 */
	protected function manage()
	{
		\IPS\Session::i()->csrfCheck();
		
		/* Flood control */
		\IPS\Request::floodCheck();
		
		# Search
		if ( \IPS\Request::i()->term )
		{
			$term = mb_strtolower( urldecode( \IPS\Request::i()->term ) );
			$where[] = array( "(song_title LIKE CONCAT( '%', ?, '%' ) OR song_singer LIKE CONCAT( '%', ?, '%' ))", $term, $term );

			if ( \IPS\Request::i()->onlysong == 1 )
			{
				$where[] = array( 'song_isPlaylist=0' );
			}
			
			$url = \IPS\Http\Url::internal( 'app=musicbox&module=musicbox&section=search&onlysong=' . \IPS\Request::i()->onlysong . '&term=' . $term );
			
			$table = new \IPS\Helpers\Table\Content( 'IPS\musicbox\Song', $url, $where );
			$table->sortOptions = array_merge( $table->sortOptions, array( 'singer' => 'song_singer' ) );	
			if ( \in_array( $table->sortBy, array( 'song_singer', 'song_title' ) ) )
			{
				$table->sortDirection = 'asc';
			}			
			$table->limit = 10;	
			$table->tableTemplate  = array( \IPS\Theme::i()->getTemplate( 'browse', 'musicbox', 'front' ), 'table' );
			$table->rowsTemplate  = array( \IPS\Theme::i()->getTemplate( 'browse', 'musicbox', 'front' ), 'searchRows' );
			$table->title = \IPS\Member::loggedIn()->language()->addToStack('mb_search_results');			
		}
			
		# Output
		\IPS\Output::i()->sidebar['enabled'] = FALSE;
		\IPS\Output::i()->breadcrumb = array();
		if ( \IPS\Dispatcher::i()->application->default == 0 )
		{
			\IPS\Output::i()->breadcrumb[] = array( \IPS\Http\Url::internal( 'app=musicbox', 'front', 'musicbox' ), \IPS\Member::loggedIn()->language()->addToStack( 'menu__musicbox_musicbox' ) );			
		}			

		\IPS\Output::i()->title = \IPS\Member::loggedIn()->language()->addToStack('mb_search_results');
		$output = \IPS\Theme::i()->getTemplate( 'global' )->searchResults( $table );
		
		if( \IPS\Request::i()->isAjax() )
		{
			\IPS\Output::i()->sendOutput( $output, 200, 'text/html', \IPS\Output::i()->httpHeaders );
		}
		else
		{
			\IPS\Output::i()->output = $output;
		}			
	}
	
}